import java.awt.*;
import java.awt.event.*;

public class JpegDialog extends Dialog implements ActionListener, ItemListener{
    protected Button button;
    protected Label label,label2,label3;
	public ImageText qua,fb,fe;
	public boolean current_frame;
	public Checkbox curr;

	class FieldValidator extends KeyAdapter {
    public void keyPressed(KeyEvent event) {
	TextField field = (TextField)event.getSource();
	String oldstring = field.getText();
	String newstring = new String();
	int value = 0, newValue;

	try {
		System.out.println("in key listen");
		if (!oldstring.equals(""))
		  value = Integer.parseInt(oldstring);

		newstring += event.getKeyChar();
		newValue = Integer.parseInt(newstring);
		newstring = field.getText();
		((ImageText)field).setValue(Integer.parseInt(newstring));
		}
	     catch(NumberFormatException e) {
		event.consume();
		field.selectAll();
	     }
           }
      }
	class FieldValidatord extends KeyAdapter {
    public void keyPressed(KeyEvent event) {
	TextField field = (TextField)event.getSource();
	String oldstring = field.getText();
	String newstring = new String();
	double value = 0, newValue;
	if(event.getKeyCode()==KeyEvent.VK_TAB || event.getKeyCode()==KeyEvent.VK_BACK_SPACE || event.getKeyCode()==KeyEvent.VK_DELETE)
		;
    else
	{
	try {
	    System.out.println("oldstring:"+oldstring);

		if (!oldstring.equals("")&&!oldstring.equals("."))
		  value = Double.parseDouble(oldstring);
        //System.out.println(value);
		newstring += event.getKeyChar();
		//System.out.println(newstring);
		if(newstring.equals("."));
		else
		{
		  newValue = Integer.parseInt(newstring);
		  oldstring = oldstring+newstring;
		  //System.out.println(oldstring);
		  value = Double.parseDouble(oldstring);
		  //field.setText(oldstring);
		 }
		}
	     catch(NumberFormatException e) {
		 //System.out.println(e.toString());
		 event.consume();
		 field.selectAll();
	     }
	 }
           }
      }

    public JpegDialog(Frame parent, String title) {
	super(parent, title);
	this.setLayout(new BorderLayout(15, 15));
	label = new Label("Quality(0-1):");
	label2 = new Label("Frames from:");
	label3 = new Label("to");

    FieldValidator validator = new FieldValidator();
    FieldValidatord validatord = new FieldValidatord();

	qua = new ImageText("1",4);
	fb = new ImageText("0",1);
	fe = new ImageText("0",1);
	fb.addKeyListener(validator);
    fe.addKeyListener(validator);
    qua.addKeyListener(validatord);

	qua.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	if(qua.getText().equals("."));
	else
	{
	System.out.println("qua.getText():"+qua.getText());
	double degree = Double.parseDouble(qua.getText());
	qua.val = degree;
	}
      }
    } );


	//this.add("Center", label);
    curr = new Checkbox("Current frame",true);
  
    curr.addItemListener(this);


	//curr.addActionListener(this);
	current_frame = true;
	fb.setEnabled(false);
	fe.setEnabled(false);
	/*fb.disable();
	fe.disable();*/
    
	button = new Button("OK");
	button.addActionListener(this);
	Panel p = new Panel();
	p.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 15));
	p.add(label);
	p.add(qua);
	p.add(curr);
	p.add(label2);
	p.add(fb);
	p.add(label3);
	p.add(fe);
	p.add(button);

	this.add("Center", p);
	this.pack();
    }

    public void itemStateChanged(ItemEvent e) {
    if (e.getSource() == curr) {
      if(current_frame == true)
	  {
		current_frame = false;
		fb.setEnabled(true);
		fe.setEnabled(true);
		/*fb.enable();
		fe.enable();*/
	  }
	  else
	  {
	    current_frame = true;
		fb.setEnabled(false);
		fe.setEnabled(false);
		/*fb.disable() ;
		fe.disable();*/
	  }
    }
    
  } // end of itemStateChanged()

    public void actionPerformed(ActionEvent e) {
	System.out.println(e.toString());
	String cmd = e.getActionCommand();
	if (cmd.equals("OK")) {
	    System.out.println("qua.getText():"+qua.getText());
		double degree = Double.parseDouble(qua.getText());
		qua.val = degree;
	    if(current_frame == false)
		{
		  System.out.println(fe.value);
		  fb.value = Integer.parseInt(fb.getText());
		  fe.value = Integer.parseInt(fe.getText());
		}
	    this.hide();
	    //this.dispose();
	}
    }


    /*public static void main(String[] args) {
	Frame f = new Frame("InfoDialogTest");
	f.setSize(200, 200);
	f.show();
	
	InfoDialog d = new InfoDialog(f, "About",
				      "This demo ...\n" +
				      "... Meg Geroch");
	d.setSize(150, 150);
	d.setLocation(100,100);
	d.show();
    }*/
}