import javax.media.j3d.*;
import javax.vecmath.*;

/* a color-coded axis system with
 * red as positive x-axis
 * green as positive y-axis
 * blue as positive z-axis
 * 
 * using simple lines
 *
 * written by M. Geroch
 */


public class myAxis extends Shape3D{

  Color3f red   = new Color3f(1.0f, 0.0f, 0.0f);
  Color3f green = new Color3f(0.0f, 1.0f, 0.0f);
  Color3f blue  = new Color3f(0.0f, 0.0f, 1.0f);


  public myAxis() {
    this.setGeometry(createGeometry());
  }

  public void hide() {
    //    if (this.isLive) {
      //      this.isLive = false;
    //}
  }


  private Geometry createGeometry() {
    // create line array
    LineArray axisLines = new LineArray(6, LineArray.COORDINATES | 
					LineArray.COLOR_3);
    axisLines.setCoordinate(0, new Point3f(0.0f, 0.0f, 0.0f));
    axisLines.setCoordinate(1, new Point3f(5f, 0.0f, 0.0f));
    axisLines.setCoordinate(2, new Point3f(0.0f, 0.0f, 0.0f));
    axisLines.setCoordinate(3, new Point3f(0.0f, 5f, 0.0f));
    axisLines.setCoordinate(4, new Point3f(0.0f, 0.0f, 0.0f));
    axisLines.setCoordinate(5, new Point3f(0.0f, 0.0f, 5f));

    axisLines.setColor(0, ColorConstants.red);
    axisLines.setColor(1, ColorConstants.red);
    axisLines.setColor(2, ColorConstants.green);
    axisLines.setColor(3, ColorConstants.green);
    axisLines.setColor(4, ColorConstants.blue);
    axisLines.setColor(5, ColorConstants.blue);

    return axisLines;

  }
}

				       




