
import java.applet.Applet;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.BorderLayout;
import java.awt.event.*;

import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.ParsingErrorException;
import com.sun.j3d.loaders.IncorrectFormatException;
import com.sun.j3d.loaders.Scene;

import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import javax.swing.*;
import javax.swing.event.*;


public class npboth extends Dialog implements ActionListener, ItemListener, ListSelectionListener{
    protected Button button,button2,button_asf,button_bac,list_rem,list_add, button_sav;
    protected Label label,label2,label3,label4;
	public ImageText qua,fb,fe;
	public StringText asfname, bacname, savename;
	public StringText filename;
	public boolean current_frame,t2d_flag,image_flag,do_flag,t3d_flag;
	public Checkbox curr,t2d,image,t3d;
	public JList list;
	public JFileChooser chooser;
	public File []  files;
	public File asffile,bacfile;
	ExampleFileFilter asfFilter, bacFilter, amcFilter;
	boolean selected;
	int start, end;

	

	class FieldValidator extends KeyAdapter {
    public void keyPressed(KeyEvent event) {
	TextField field = (TextField)event.getSource();
	String oldstring = field.getText();
	String newstring = new String();
	int value = 0, newValue;

	try {
		System.out.println("in key listen");
		if (!oldstring.equals(""))
		  value = Integer.parseInt(oldstring);

		newstring += event.getKeyChar();
		newValue = Integer.parseInt(newstring);
		newstring = field.getText();
		((ImageText)field).setValue(Integer.parseInt(newstring));
		}
	     catch(NumberFormatException e) {
		event.consume();
		field.selectAll();
	     }
           }
      }
	class FieldValidatort extends KeyAdapter {
    public void keyPressed(KeyEvent event) {
	TextField field = (TextField)event.getSource();
	 }
    }

	class FieldValidatord extends KeyAdapter {
    public void keyPressed(KeyEvent event) {
	TextField field = (TextField)event.getSource();
	String oldstring = field.getText();
	String newstring = new String();
	double value = 0, newValue;
	if(event.getKeyCode()==KeyEvent.VK_TAB || event.getKeyCode()==KeyEvent.VK_BACK_SPACE || event.getKeyCode()==KeyEvent.VK_DELETE)
		;
    else
	{
	try {
	    System.out.println("oldstring:"+oldstring);

		if (!oldstring.equals("")&&!oldstring.equals("."))
		  value = Double.parseDouble(oldstring);
        
		newstring += event.getKeyChar();
		
		if(newstring.equals("."));
		else
		{
		  newValue = Integer.parseInt(newstring);
		  oldstring = oldstring+newstring;
		  
		  value = Double.parseDouble(oldstring);
		  
		 }
		}
	     catch(NumberFormatException e) {
		 
		 event.consume();
		 field.selectAll();
	     }
	 }
           }
      }

    public npboth(Frame parent, String title, JFileChooser ch,ExampleFileFilter asff, ExampleFileFilter bacf, ExampleFileFilter amcf) {
	super(parent, title);
	chooser = ch;
	asfFilter = asff;
	bacFilter = bacf;
	amcFilter = amcf;
	selected = false;
	asffile = null;
	bacfile = null;
	this.setLayout(new BorderLayout(15, 15));
	label = new Label("Quality(0-1):");
	label2 = new Label("Frames from:");
	label3 = new Label("to");
	label4 = new Label("Output File Name (extensions will be added):");

    FieldValidator validator = new FieldValidator();
	FieldValidatort validatort = new FieldValidatort();
    FieldValidatord validatord = new FieldValidatord();
    filename = new StringText("",20);
	filename.addKeyListener(validatort);
	asfname = new StringText("",30);
	bacname = new StringText("",30);
	savename = new StringText("",30);
	asfname.addKeyListener(validatort);
	bacname.addKeyListener(validatort);
	savename.addKeyListener(validatort);


	qua = new ImageText("1",4);
	fb = new ImageText("0",1);
	fe = new ImageText("0",1);
	fb.addKeyListener(validator);
    fe.addKeyListener(validator);
    qua.addKeyListener(validatord);

	qua.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	if(qua.getText().equals("."));
	else
	{
	System.out.println("qua.getText():"+qua.getText());
	double degree = Double.parseDouble(qua.getText());
	qua.val = degree;
	}
      }
    } );


	//this.add("Center", label);
    curr = new Checkbox("Current frame",true);
    curr.addItemListener(this);
	Panel p2 = new Panel();
	p2.setLayout(new FlowLayout(FlowLayout.CENTER, 2, 2));
	p2.add(label4);
	p2.add(filename);
	

	Panel p1 = new Panel();
	p1.setLayout(new FlowLayout(FlowLayout.CENTER, 2, 2));

	t2d = new Checkbox("t2d",true);
    t2d.addItemListener(this);

	t3d = new Checkbox("t3d",true);
    t3d.addItemListener(this);

	image = new Checkbox("image",true);
    image.addItemListener(this);

	p1.add(t2d);
	p1.add(image);
	p1.add(t3d);

	//curr.addActionListener(this);
	current_frame = true;
	t2d_flag = true;
	image_flag = true;
	t3d_flag = true;
	fb.setEnabled(false);
	fe.setEnabled(false);
	
    
	button = new Button("OK");
	button2 = new Button("Cancel");
	button_asf = new Button("Browse a asf file");
	button_bac = new Button("Browse a bac file");
	button_sav = new Button("Save to directory");
	button_asf.addActionListener(this);
	button_bac.addActionListener(this);
	button_sav.addActionListener(this);
	button.addActionListener(this);
	button2.addActionListener(this);
	p2.add(button);
	p2.add(button2);
	Panel p = new Panel();
	p.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 15));
	p.add(label);
	p.add(qua);
	p.add(curr);
	p.add(label2);
	p.add(fb);
	p.add(label3);
	p.add(fe);
	//p.add(button);

    list = new JList();
	list.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION );
	list.addListSelectionListener(this);
	JScrollPane listscroll=new JScrollPane(list);

	Panel pp = new Panel();
	pp.setLayout(new BorderLayout(15, 15));
	pp.add("North",p1);
	pp.add("Center",p);
	pp.add("South",p2);

	Panel pb = new Panel();
	pb.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 15));
	list_rem = new Button("Remove amc file");
	list_add = new Button("Add amc files");
	list_rem.addActionListener(this);
	list_add.addActionListener(this);
	pb.add(list_rem);
	pb.add(list_add);

	Panel pl = new Panel();
	pl.setLayout(new FlowLayout(FlowLayout.CENTER, 15,15));
	pl.add(listscroll);

	Panel pll = new Panel();
	pll.setLayout(new BorderLayout(15, 15));
	pll.add("North",pl);
	pll.add("South",pb);

	Panel pasf = new Panel();
	pasf.setLayout(new FlowLayout(FlowLayout.CENTER, 15,15));
	pasf.add(asfname);
	pasf.add(button_asf);

	Panel psavef = new Panel();
	psavef.setLayout(new FlowLayout(FlowLayout.CENTER, 15,15));
	psavef.add(savename);
	psavef.add(button_sav);

	Panel pbac = new Panel();
	pbac.setLayout(new FlowLayout(FlowLayout.CENTER, 15,15));
	pbac.add(bacname);
	pbac.add(button_bac);

	Panel ps = new Panel();
	ps.setLayout(new BorderLayout(15, 15));
	ps.add("North",pasf);
	ps.add("Center",pbac);
	ps.add("South",psavef);

	Panel pss = new Panel();
	pss.setLayout(new BorderLayout(15, 15));
	pss.add("North",ps);
	pss.add("South",pp);

	this.add("West", pss);
    this.add("East",pll);
	//this.add("South",p2);
	this.pack();
    }

  public void valueChanged(ListSelectionEvent e){

  	 JList thelist=(JList)e.getSource();
	 if(thelist.isSelectionEmpty())
			return;
	 else
	 {
		start = thelist.getAnchorSelectionIndex();
		end = thelist.getLeadSelectionIndex();
		selected = true;
		System.out.println("selected from "+start+" to "+end);
		/*int selected;
		selected = thelist.getSelectedIndex();*/
		
	 }

  }


    public void itemStateChanged(ItemEvent e) {
    if (e.getSource() == curr) {
      if(current_frame == true)
	  {
		current_frame = false;
		fb.setEnabled(true);
		fe.setEnabled(true);
	  }
	  else
	  {
	    current_frame = true;
		fb.setEnabled(false);
		fe.setEnabled(false);
	  }
    }
	else if (e.getSource() == t2d) {
      if(t2d_flag == true)
	  {
		t2d_flag = false;
	  }
	  else
	  {
	    t2d_flag = true;
	  }
    }
	else if (e.getSource() == t3d) {
      if(t3d_flag == true)
	  {
		t3d_flag = false;
	  }
	  else
	  {
	    t3d_flag = true;
	  }
    }
	else if (e.getSource() == image) {
      if(image_flag == true)
	  {
		image_flag = false;
		curr.setEnabled(false);
		qua.setEnabled(false);
		//curr.setState(false);
		//current_frame = false;
		fb.setEnabled(false);
		fe.setEnabled(false);
	  }
	  else
	  {
	    image_flag = true;
          curr.setEnabled(true);
	    qua.setEnabled(true);
	    //curr.setState(true);
	    if(!current_frame)
          {
	    	fb.setEnabled(true);
	    	fe.setEnabled(true);
	    }
	    else
	    {
	    	fb.setEnabled(false);
	    	fe.setEnabled(false);
	    }
		//p.setEnable(true);
	  }
    }
    
  } // end of itemStateChanged()

    public void actionPerformed(ActionEvent e) {
	System.out.println(e.toString());
	String cmd = e.getActionCommand();
	if (cmd.equals("OK")) {
	    filename.string = filename.getText();
	    //System.out.println("qua.getText():"+qua.getText());
		double degree = Double.parseDouble(qua.getText());
		qua.val = degree;
	    if(current_frame == false)
		{
		  System.out.println(fe.value);
		  fb.value = Integer.parseInt(fb.getText());
		  fe.value = Integer.parseInt(fe.getText());
		}
	   if(!t2d_flag && !image_flag && !t3d_flag) 
		{
		System.out.println("do_flag:false");
	    do_flag = false;
		}
	   else
	    do_flag = true;
	   if(bacfile == null)
			do_flag = false;
	   if(files == null)
			do_flag = false;
	   else if(files[0] == null)
		    do_flag = false;
		//System.out.println("files[0]"+files[0]);
		//System.out.println("bacfile"+bacfile);				
	    this.hide();
	    //this.dispose();
	}
	else if(cmd.equals("Cancel")){
	    do_flag = false;
		this.hide();
	}
	else if(cmd.equals("Add amc files")){
		int i;
		chooser.addChoosableFileFilter(amcFilter);
		//if(filedir == null)filedir = new File(".");
		//chooser.setCurrentDirectory(filedir);
		chooser.setMultiSelectionEnabled(true);
		chooser.showOpenDialog(null);
		
		
		File filedir = chooser.getSelectedFile();
		
		if(filedir == null)return;
		File files_temp[] = chooser.getSelectedFiles();
		int length = files_temp.length;
		if(files != null)
		{
		File files_temp2[] = new File[length+files.length];
		for(i=0;i<files.length;i++)
			files_temp2[i] = files[i];
		for(i=files.length;i<files.length+length;i++)
			files_temp2[i] = files_temp[i-files.length];
		files = files_temp2;
		}
		else
			files = files_temp;
		list.setListData(files);
		System.out.println("files.length:"+files.length);
		chooser.removeChoosableFileFilter(amcFilter);
		chooser.setMultiSelectionEnabled(false);
		selected = true;

	}
	else if(cmd.equals("Remove amc file")){
	    if(selected)
		{
			System.out.println("start "+start+"end "+end);
			if(start>end)
			{
				int temp = start;
				start = end;
				end = temp;
			}
			File [] files_new = new File[files.length-end+start-1];
			for(int i = 0;i<start;i++)
			{
					files_new[i] = files[i];
			}
			System.out.println(files.length-end);
			for(int i=0;i<files.length-end-1;i++)
			{
				   files_new[start+i] = files[end+i];
			}
			files = files_new;
			list.setListData(files);//removeSelectionInterval(start,end);
			//list.updateUI();
			selected = false;
		}
	}
	else if(cmd.equals("Browse a asf file")){
	chooser.addChoosableFileFilter(asfFilter);
	chooser.showOpenDialog(null);
	asffile = chooser.getSelectedFile();
		
	if(asffile == null)return;
	
    String fullfilename = asffile.getAbsolutePath();
	asfname.setValue(fullfilename);
	asfname.setText(fullfilename);
	}
	else if(cmd.equals("Browse a bac file")){
	chooser.addChoosableFileFilter(bacFilter);
	chooser.showOpenDialog(null);
	bacfile = chooser.getSelectedFile();
		
	if(bacfile == null)return;
	
    String fullfilename = bacfile.getAbsolutePath();
	bacname.setValue(fullfilename);
	bacname.setText(fullfilename);
	}
	else if(cmd.equals("Save to directory"))
	{
	//chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	chooser.showOpenDialog(null);
	File file = chooser.getCurrentDirectory();
	//File file = chooser.getSelectedFile();
	//chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		
	if(file == null)
	{
		savename.string = null;
		savename.setText("");
	}
	else
	{
	    String fullfilename = file.getAbsolutePath();
		savename.setValue(fullfilename);
		savename.setText(fullfilename);
	}

    }
	}


    /*public static void main(String[] args) {
	Frame f = new Frame("InfoDialogTest");
	f.setSize(800, 800);
	f.show();
	
	npboth d = new npboth(f, "About");
	d.setSize(150, 150);
	d.setLocation(100,100);
	d.show();
    }*/
}
