import javax.media.j3d.*;
import javax.media.j3d.Appearance;
import javax.vecmath.*;

/* a color-coded axis system with
 * red as positive x-axis
 * green as positive y-axis
 * blue as positive z-axis
 * 
 * using simple lines
 *
 * written by M. Geroch
 */


public class skeleton extends Shape3D{

  /*private Geometry createGeometry(asf_struct joints[],int number_joints,int frame,boolean app[]) {
    
    int numlines = number_joints-1;
	int count = 0;
	int i,j;
    

    // create line array
    TriangleArray planeLines = new TriangleArray(18*numlines, TriangleArray.COORDINATES | 
					TriangleArray.COLOR_3);
    for (j = 0; j < number_joints; j++) {
	  for(i=0;i<joints[j].number_son;i++)
	  {
		 if(app[j] && app[joints[j].sons[i]])
		 {
		 planeLines.setCoordinate(3*count, new Point3f(joints[j].amc_position[frame][0], joints[j].amc_position[frame][1], joints[j].amc_position[frame][2]));
         planeLines.setCoordinate(3*count+1, new Point3f(joints[joints[j].sons[i]].pos_roottonode_right[frame][0], joints[joints[j].sons[i]].pos_roottonode_right[frame][1],joints[joints[j].sons[i]].pos_roottonode_right[frame][2]));	
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[joints[j].sons[i]].pos_front_up[frame][0], joints[joints[j].sons[i]].pos_front_up[frame][1],joints[joints[j].sons[i]].pos_front_up[frame][2]));	
		 count++;

		 planeLines.setCoordinate(3*count, new Point3f(joints[j].amc_position[frame][0], joints[j].amc_position[frame][1], joints[j].amc_position[frame][2]));
         planeLines.setCoordinate(3*count+1, new Point3f(joints[joints[j].sons[i]].pos_front_up[frame][0], joints[joints[j].sons[i]].pos_front_up[frame][1],joints[joints[j].sons[i]].pos_front_up[frame][2]));	
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[joints[j].sons[i]].pos_roottonode_left[frame][0], joints[joints[j].sons[i]].pos_roottonode_left[frame][1],joints[joints[j].sons[i]].pos_roottonode_left[frame][2]));	
		 count++;

		 planeLines.setCoordinate(3*count, new Point3f(joints[j].amc_position[frame][0], joints[j].amc_position[frame][1], joints[j].amc_position[frame][2]));
         planeLines.setCoordinate(3*count+1, new Point3f(joints[joints[j].sons[i]].pos_roottonode_left[frame][0], joints[joints[j].sons[i]].pos_roottonode_left[frame][1],joints[joints[j].sons[i]].pos_roottonode_left[frame][2]));	
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[joints[j].sons[i]].pos_roottonode_right[frame][0], joints[joints[j].sons[i]].pos_roottonode_right[frame][1],joints[joints[j].sons[i]].pos_roottonode_right[frame][2]));	
		 count++;

		 planeLines.setCoordinate(3*count, new Point3f(joints[joints[j].sons[i]].amc_position[frame][0], joints[joints[j].sons[i]].amc_position[frame][1],joints[joints[j].sons[i]].amc_position[frame][2]));	
		 planeLines.setCoordinate(3*count+1, new Point3f(joints[joints[j].sons[i]].pos_front_up[frame][0], joints[joints[j].sons[i]].pos_front_up[frame][1],joints[joints[j].sons[i]].pos_front_up[frame][2]));	
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[joints[j].sons[i]].pos_roottonode_right[frame][0], joints[joints[j].sons[i]].pos_roottonode_right[frame][1],joints[joints[j].sons[i]].pos_roottonode_right[frame][2]));
		 count++;

		 planeLines.setCoordinate(3*count, new Point3f(joints[joints[j].sons[i]].amc_position[frame][0], joints[joints[j].sons[i]].amc_position[frame][1],joints[joints[j].sons[i]].amc_position[frame][2]));	
         planeLines.setCoordinate(3*count+1, new Point3f(joints[joints[j].sons[i]].pos_roottonode_left[frame][0], joints[joints[j].sons[i]].pos_roottonode_left[frame][1],joints[joints[j].sons[i]].pos_roottonode_left[frame][2]));	
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[joints[j].sons[i]].pos_front_up[frame][0], joints[joints[j].sons[i]].pos_front_up[frame][1],joints[joints[j].sons[i]].pos_front_up[frame][2]));	
		 count++;

		 planeLines.setCoordinate(3*count, new Point3f(joints[joints[j].sons[i]].amc_position[frame][0], joints[joints[j].sons[i]].amc_position[frame][1],joints[joints[j].sons[i]].amc_position[frame][2]));	
         planeLines.setCoordinate(3*count+1, new Point3f(joints[joints[j].sons[i]].pos_roottonode_right[frame][0], joints[joints[j].sons[i]].pos_roottonode_right[frame][1],joints[joints[j].sons[i]].pos_roottonode_right[frame][2]));	
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[joints[j].sons[i]].pos_roottonode_left[frame][0], joints[joints[j].sons[i]].pos_roottonode_left[frame][1],joints[joints[j].sons[i]].pos_roottonode_left[frame][2]));	
		 count++;

		 }
	  }
    }
	
    for (j = 0; j < 3*count; j++)
	{
      planeLines.setColor(j, ColorConstants.yellow);
	}
			       
    return planeLines;

  }*/
  public skeleton(asf_struct joints[],int number_joints,int frame,boolean app[],int linknet[][]) {
	Color3f eColor    = new Color3f(0.0f, 0.0f, 0.0f);
    Color3f sColor    = new Color3f(0.0f, 0.0f, 0.0f);
    Color3f objColor  = new Color3f(0.1f, 0.1f, 0.1f);

    Material m = new Material(objColor, eColor, objColor, sColor, 0.0f);
	PolygonAttributes p = new PolygonAttributes(PolygonAttributes.POLYGON_LINE,PolygonAttributes.CULL_BACK,0.0f);
	p.setPolygonOffsetFactor(0.1f);
    Appearance a = new Appearance();

    m.setLightingEnable(true);

    a.setMaterial(m);
	//a.setPolygonAttributes(p);

    this.setGeometry(createGeometry(joints,number_joints,frame,app,linknet));
	this.setAppearance(a);
  }
  private Geometry createGeometry(asf_struct joints[],int number_joints,int frame,boolean app[],int linknet[][]) {
    
    int numlines = number_joints-1;
	int count = 0;
	int i,j;
    for(i=0;i<number_joints;i++)
	{
		for(j=0;j<number_joints-1;j++)
			if(linknet[i][j]!=-1)count++;
	}

    // create line array
	if(count==0)return null;
	
    TriangleArray planeLines = new TriangleArray(18*count, TriangleArray.COORDINATES | 
					TriangleArray.COLOR_3 | TriangleArray.NORMALS);
	count=0;
	Vector3f d1,d2,d3;
	d3 = new Vector3f(0.0f,0.0f,0.0f);
	float x1[],x2[],x3[];
	x1 = new float[3];
	x2 = new float[3];
	x3 = new float[3];
    for (i = 0; i < number_joints; i++) {
	  for(j=0;j<number_joints-1;j++)
	  {
	     if(linknet[i][j]!=-1)
		 {
		 /*planeLines.setCoordinate(2*count, new Point3f(joints[i].amc_position[frame][0], joints[i].amc_position[frame][1], joints[i].amc_position[frame][2]));
         planeLines.setCoordinate(2*count+1, new Point3f(joints[linknet[i][j]].amc_position[frame][0], joints[linknet[i][j]].amc_position[frame][1],joints[linknet[i][j]].amc_position[frame][2]));	
		 count++;*/
		 
		 planeLines.setCoordinate(3*count, new Point3f(joints[i].amc_position[frame][0], joints[i].amc_position[frame][1], joints[i].amc_position[frame][2]));
		 x1[0] = joints[i].amc_position[frame][0];
		 x1[1] = joints[i].amc_position[frame][1];
		 x1[2] = joints[i].amc_position[frame][2];
         planeLines.setCoordinate(3*count+1, new Point3f(joints[linknet[i][j]].pos_roottonode_right[frame][0], joints[linknet[i][j]].pos_roottonode_right[frame][1],joints[linknet[i][j]].pos_roottonode_right[frame][2]));	
		 x2[0] = joints[linknet[i][j]].pos_roottonode_right[frame][0];
		 x2[1] = joints[linknet[i][j]].pos_roottonode_right[frame][1];
		 x2[2] = joints[linknet[i][j]].pos_roottonode_right[frame][2];
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[linknet[i][j]].pos_front_up[frame][0], joints[linknet[i][j]].pos_front_up[frame][1],joints[linknet[i][j]].pos_front_up[frame][2]));	
		 x3[0] = joints[linknet[i][j]].pos_front_up[frame][0];
		 x3[1] = joints[linknet[i][j]].pos_front_up[frame][1];
		 x3[2] = joints[linknet[i][j]].pos_front_up[frame][2];

		 d1 = new Vector3f(x2[0]-x1[0],x2[1]-x1[1],x2[2]-x1[2]);
		 d2 = new Vector3f(x3[0]-x2[0],x3[1]-x2[1],x3[2]-x2[2]);
		 d3.cross(d1,d2);

		 planeLines.setNormal(3*count,d3);
		 planeLines.setNormal(3*count+1,d3);
		 planeLines.setNormal(3*count+2,d3);

		 count++;

		 planeLines.setCoordinate(3*count, new Point3f(joints[i].amc_position[frame][0], joints[i].amc_position[frame][1], joints[i].amc_position[frame][2]));
		 x1[0] = joints[i].amc_position[frame][0];
		 x1[1] = joints[i].amc_position[frame][1];
		 x1[2] = joints[i].amc_position[frame][2];
         planeLines.setCoordinate(3*count+1, new Point3f(joints[linknet[i][j]].pos_front_up[frame][0], joints[linknet[i][j]].pos_front_up[frame][1],joints[linknet[i][j]].pos_front_up[frame][2]));	
		 x2[0] = joints[linknet[i][j]].pos_front_up[frame][0];
		 x2[1] = joints[linknet[i][j]].pos_front_up[frame][1];
		 x2[2] = joints[linknet[i][j]].pos_front_up[frame][2];
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[linknet[i][j]].pos_roottonode_left[frame][0], joints[linknet[i][j]].pos_roottonode_left[frame][1],joints[linknet[i][j]].pos_roottonode_left[frame][2]));
		 x3[0] = joints[linknet[i][j]].pos_roottonode_left[frame][0];
		 x3[1] = joints[linknet[i][j]].pos_roottonode_left[frame][1];
		 x3[2] = joints[linknet[i][j]].pos_roottonode_left[frame][2];

		 d1 = new Vector3f(x2[0]-x1[0],x2[1]-x1[1],x2[2]-x1[2]);
		 d2 = new Vector3f(x3[0]-x2[0],x3[1]-x2[1],x3[2]-x2[2]);
		 d3.cross(d1,d2);

		 planeLines.setNormal(3*count,d3);
		 planeLines.setNormal(3*count+1,d3);
		 planeLines.setNormal(3*count+2,d3);
		 count++;

		 planeLines.setCoordinate(3*count, new Point3f(joints[i].amc_position[frame][0], joints[i].amc_position[frame][1], joints[i].amc_position[frame][2]));
		 x1[0] = joints[i].amc_position[frame][0];
		 x1[1] = joints[i].amc_position[frame][1];
		 x1[2] = joints[i].amc_position[frame][2];
         planeLines.setCoordinate(3*count+1, new Point3f(joints[linknet[i][j]].pos_roottonode_left[frame][0], joints[linknet[i][j]].pos_roottonode_left[frame][1],joints[linknet[i][j]].pos_roottonode_left[frame][2]));	
		 x2[0] = joints[linknet[i][j]].pos_roottonode_left[frame][0];
		 x2[1] = joints[linknet[i][j]].pos_roottonode_left[frame][1];
		 x2[2] = joints[linknet[i][j]].pos_roottonode_left[frame][2];
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[linknet[i][j]].pos_roottonode_right[frame][0], joints[linknet[i][j]].pos_roottonode_right[frame][1],joints[linknet[i][j]].pos_roottonode_right[frame][2]));	
		 x3[0] = joints[linknet[i][j]].pos_roottonode_right[frame][0];
		 x3[1] = joints[linknet[i][j]].pos_roottonode_right[frame][1];
		 x3[2] = joints[linknet[i][j]].pos_roottonode_right[frame][2];

		 d1 = new Vector3f(x2[0]-x1[0],x2[1]-x1[1],x2[2]-x1[2]);
		 d2 = new Vector3f(x3[0]-x2[0],x3[1]-x2[1],x3[2]-x2[2]);
		 d3.cross(d1,d2);

		 planeLines.setNormal(3*count,d3);
		 planeLines.setNormal(3*count+1,d3);
		 planeLines.setNormal(3*count+2,d3);
		 count++;

		 planeLines.setCoordinate(3*count, new Point3f(joints[linknet[i][j]].amc_position[frame][0], joints[linknet[i][j]].amc_position[frame][1],joints[linknet[i][j]].amc_position[frame][2]));	
		 x1[0] = joints[linknet[i][j]].amc_position[frame][0];
		 x1[1] = joints[linknet[i][j]].amc_position[frame][1];
		 x1[2] = joints[linknet[i][j]].amc_position[frame][2];
		 planeLines.setCoordinate(3*count+1, new Point3f(joints[linknet[i][j]].pos_front_up[frame][0], joints[linknet[i][j]].pos_front_up[frame][1],joints[linknet[i][j]].pos_front_up[frame][2]));	
		 x2[0] = joints[linknet[i][j]].pos_front_up[frame][0];
		 x2[1] = joints[linknet[i][j]].pos_front_up[frame][1];
		 x2[2] = joints[linknet[i][j]].pos_front_up[frame][2];
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[linknet[i][j]].pos_roottonode_right[frame][0], joints[linknet[i][j]].pos_roottonode_right[frame][1],joints[linknet[i][j]].pos_roottonode_right[frame][2]));
		 x3[0] = joints[linknet[i][j]].pos_roottonode_right[frame][0];
		 x3[1] = joints[linknet[i][j]].pos_roottonode_right[frame][1];
		 x3[2] = joints[linknet[i][j]].pos_roottonode_right[frame][2];

		 d1 = new Vector3f(x2[0]-x1[0],x2[1]-x1[1],x2[2]-x1[2]);
		 d2 = new Vector3f(x3[0]-x2[0],x3[1]-x2[1],x3[2]-x2[2]);
		 d3.cross(d1,d2);

		 planeLines.setNormal(3*count,d3);
		 planeLines.setNormal(3*count+1,d3);
		 planeLines.setNormal(3*count+2,d3);
		 count++;

		 planeLines.setCoordinate(3*count, new Point3f(joints[linknet[i][j]].amc_position[frame][0], joints[linknet[i][j]].amc_position[frame][1],joints[linknet[i][j]].amc_position[frame][2]));	
		 x1[0] = joints[linknet[i][j]].amc_position[frame][0];
		 x1[1] = joints[linknet[i][j]].amc_position[frame][1];
		 x1[2] = joints[linknet[i][j]].amc_position[frame][2];
         planeLines.setCoordinate(3*count+1, new Point3f(joints[linknet[i][j]].pos_roottonode_left[frame][0], joints[linknet[i][j]].pos_roottonode_left[frame][1],joints[linknet[i][j]].pos_roottonode_left[frame][2]));	
		 x2[0] = joints[linknet[i][j]].pos_roottonode_left[frame][0];
		 x2[1] = joints[linknet[i][j]].pos_roottonode_left[frame][1];
		 x2[2] = joints[linknet[i][j]].pos_roottonode_left[frame][2];
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[linknet[i][j]].pos_front_up[frame][0], joints[linknet[i][j]].pos_front_up[frame][1],joints[linknet[i][j]].pos_front_up[frame][2]));	
		 x3[0] = joints[linknet[i][j]].pos_front_up[frame][0];
		 x3[1] = joints[linknet[i][j]].pos_front_up[frame][1];
		 x3[2] = joints[linknet[i][j]].pos_front_up[frame][2];

		 d1 = new Vector3f(x2[0]-x1[0],x2[1]-x1[1],x2[2]-x1[2]);
		 d2 = new Vector3f(x3[0]-x2[0],x3[1]-x2[1],x3[2]-x2[2]);
		 d3.cross(d1,d2);

		 planeLines.setNormal(3*count,d3);
		 planeLines.setNormal(3*count+1,d3);
		 planeLines.setNormal(3*count+2,d3);
		 count++;

		 planeLines.setCoordinate(3*count, new Point3f(joints[linknet[i][j]].amc_position[frame][0], joints[linknet[i][j]].amc_position[frame][1],joints[linknet[i][j]].amc_position[frame][2]));	
		 x1[0] = joints[linknet[i][j]].amc_position[frame][0];
		 x1[1] = joints[linknet[i][j]].amc_position[frame][1];
		 x1[2] = joints[linknet[i][j]].amc_position[frame][2];
         planeLines.setCoordinate(3*count+1, new Point3f(joints[linknet[i][j]].pos_roottonode_right[frame][0], joints[linknet[i][j]].pos_roottonode_right[frame][1],joints[linknet[i][j]].pos_roottonode_right[frame][2]));	
		 x2[0] = joints[linknet[i][j]].pos_roottonode_right[frame][0];
		 x2[1] = joints[linknet[i][j]].pos_roottonode_right[frame][1];
		 x2[2] = joints[linknet[i][j]].pos_roottonode_right[frame][2];
		 planeLines.setCoordinate(3*count+2, new Point3f(joints[linknet[i][j]].pos_roottonode_left[frame][0], joints[linknet[i][j]].pos_roottonode_left[frame][1],joints[linknet[i][j]].pos_roottonode_left[frame][2]));	
		 x3[0] = joints[linknet[i][j]].pos_roottonode_left[frame][0];
		 x3[1] = joints[linknet[i][j]].pos_roottonode_left[frame][1];
		 x3[2] = joints[linknet[i][j]].pos_roottonode_left[frame][2];

		 d1 = new Vector3f(x2[0]-x1[0],x2[1]-x1[1],x2[2]-x1[2]);
		 d2 = new Vector3f(x3[0]-x2[0],x3[1]-x2[1],x3[2]-x2[2]);
		 d3.cross(d1,d2);

		 planeLines.setNormal(3*count,d3);
		 planeLines.setNormal(3*count+1,d3);
		 planeLines.setNormal(3*count+2,d3);
		 count++;

		 }
	  }
    }
	for (j = 0; j < 3*count; j++)
	{
      planeLines.setColor(j, ColorConstants.yellow);
	}
			       
    return planeLines;

  }

  
}